package com.dataart.viewer.product.converter;

import com.dataart.viewer.product.model.vo.FilterVO;
import java.util.Collections;
import java.util.List;
import org.apache.commons.lang.Validate;
import org.codehaus.jackson.type.TypeReference;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 *
 * @author volkodavav
 */
@Component
public class FilterConverter implements InitializingBean {

    @Autowired
    protected JsonConverter jsonConverter;

    public List<FilterVO> fromJsonToList(String filterJson) {
        if (filterJson == null || filterJson.isEmpty()) {
            return Collections.EMPTY_LIST;
        }

        List<FilterVO> filterUI = jsonConverter.fromStringToObject(new TypeReference<List<FilterVO>>() {
        }, filterJson);

        return filterUI;
    }

    public void setJsonConverter(JsonConverter jsonConverter) {
        this.jsonConverter = jsonConverter;
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        Validate.notNull(jsonConverter, "jsonConverter expected");
    }
}
