package com.dataart.viewer.product.converter;

import com.dataart.viewer.product.model.vo.SortVO;
import java.util.Collections;
import java.util.List;
import org.apache.commons.lang.Validate;
import org.codehaus.jackson.type.TypeReference;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 *
 * @author volkodavav
 */
@Component
public class SortConverter implements InitializingBean {

    @Autowired
    protected JsonConverter jsonConverter;

    public List<SortVO> fromJsonToList(String sortJson) {
        if (sortJson == null || sortJson.isEmpty()) {
            return Collections.EMPTY_LIST;
        }

        List<SortVO> sortUI = jsonConverter.fromStringToObject(new TypeReference<List<SortVO>>() {
        }, sortJson);

        return sortUI;
    }

    public void setJsonConverter(JsonConverter jsonConverter) {
        this.jsonConverter = jsonConverter;
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        Validate.notNull(jsonConverter, "jsonConverter expected");
    }
}
