package com.dataart.viewer.product.mapper;

import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.springframework.stereotype.Service;
import org.springframework.validation.Errors;
import org.springframework.validation.ObjectError;

/**
 * Mapping application errors
 *
 * @author volkodavav
 */
@Service
public class ErrorMapper {

    protected Logger logger = LoggerFactory.getLogger(getClass());

    public Map<String, String> transformErrors(Errors errors) {
        Map<String, String> errorsMap = transformErrors(errors.getAllErrors());

        return errorsMap;
    }

    public Map<String, String> transformErrors(List<ObjectError> allErrors) {
        if (allErrors == null || allErrors.isEmpty()) {
            return Collections.EMPTY_MAP;
        }

        Map<String, String> errorsMap = new HashMap<String, String>();

        for (ObjectError error : allErrors) {
            String key = error.getObjectName();
            String value = error.getDefaultMessage();
            errorsMap.put(key, value);
        }

        return errorsMap;
    }

    protected Locale getLocale() {
        return Locale.getDefault();
    }
}
