package com.dataart.viewer.product.model.impl;

import com.dataart.viewer.product.model.BusinessModel;
import java.math.BigDecimal;
import javax.persistence.AttributeOverride;
import javax.persistence.CascadeType;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

/**
 *
 * @author volkodavav
 */
@Entity
@Table(name = "T_PRODUCT")
@AttributeOverride(name = "id", column =
    @Column(name = "PRODUCT_ID", nullable = false))
public class Product extends BusinessModel {

    @Column(name = "PRODUCT_NAME", nullable = false, length = 255)
    private String name;
    @Column(name = "PRODUCT_PRICE", nullable = false, precision = 8, scale = 2)
    private BigDecimal price;
    @ManyToOne(fetch = FetchType.EAGER, cascade = CascadeType.ALL, optional = false)
    @JoinColumn(name = "GROUP_ID")
    private ProductGroup group;

    public Product() {
    }

    public Product(String name, BigDecimal price, ProductGroup group) {
        this.name = name;
        this.price = price;
        this.group = group;
    }

    /**
     * List all fields here
     */
    public static enum FIELDS {

        NAME, PRICE, GROUP;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public BigDecimal getPrice() {
        return price;
    }

    public void setPrice(BigDecimal price) {
        this.price = price;
    }

    public ProductGroup getGroup() {
        return group;
    }

    public void setGroup(ProductGroup group) {
        this.group = group;
    }

    @Override
    public String toString() {
        return "Product Name=" + name + ", price=" + price + ", group=" + group;
    }
}
