package com.dataart.viewer.product.model.impl;

import com.dataart.viewer.product.model.BusinessModel;
import java.util.List;
import javax.persistence.AttributeOverride;
import javax.persistence.CascadeType;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 *
 * @author volkodavav
 */
@Entity
@Table(name = "T_GROUP")
@AttributeOverride(name = "id", column =
    @Column(name = "GROUP_ID", nullable = false))
public class ProductGroup extends BusinessModel {

    @Column(name = "GROUP_NAME", nullable = false, length = 255, unique = true)
    private String name;
    @OneToMany(mappedBy = "group", fetch = FetchType.LAZY, cascade = CascadeType.ALL)
    private List<Product> products;

    public ProductGroup() {
    }

    public ProductGroup(String name) {
        this.name = name;
    }

    /**
     * List all fields here
     */
    public static enum FIELDS {

        NAME;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<Product> getProducts() {
        return products;
    }

    public void setProducts(List<Product> products) {
        this.products = products;
    }

    @Override
    public String toString() {
        return "Product group name=" + name;
    }
}
