package com.dataart.viewer.product.model.vo;

import org.codehaus.jackson.annotate.JsonAutoDetect;
import org.codehaus.jackson.annotate.JsonCreator;
import org.codehaus.jackson.annotate.JsonValue;

/**
 *
 * @author volkodavav
 */
@JsonAutoDetect
public class FilterVO {

    public static enum Type {

        STRING, DATE, BOOLEAN, NUMERIC, LIST;

        @JsonValue
        public String value() {
            return name();
        }

        @JsonCreator
        public static Type forValue(String value) {
            if (value == null || value.trim().isEmpty()) {
                throw new IllegalArgumentException("Filter Type must not be null or empty: " + value);
            }

            return Type.valueOf(value.trim().toUpperCase());
        }
    }

    public static enum Comparison {

        LT, GT, EQ;

        @JsonValue
        public String value() {
            return name();
        }

        @JsonCreator
        public static Comparison forValue(String value) {
            if (value == null || value.trim().isEmpty()) {
                throw new IllegalArgumentException("Filter Comparison must not be null or empty: " + value);
            }

            return Comparison.valueOf(value.trim().toUpperCase());
        }
    }
    private Type type;
    private Comparison comparison;
    private Object value;
    private String field;

    public FilterVO() {
    }

    public Type getType() {
        return type;
    }

    public void setType(Type type) {
        this.type = type;
    }

    public Comparison getComparison() {
        return comparison;
    }

    public void setComparison(Comparison comparison) {
        this.comparison = comparison;
    }

    public Object getValue() {
        return value;
    }

    public void setValue(Object value) {
        this.value = value;
    }

    public String getField() {
        return field;
    }

    public void setField(String field) {
        this.field = field;
    }

    @Override
    public String toString() {
        return "Filter type=" + type + ", comparison=" + comparison + ", value=" + value + ", field=" + field;
    }
}
