package com.dataart.viewer.product.model.vo;

import org.codehaus.jackson.annotate.JsonAutoDetect;
import org.codehaus.jackson.annotate.JsonCreator;
import org.codehaus.jackson.annotate.JsonValue;

/**
 *
 * @author volkodavav
 */
@JsonAutoDetect
public class SortVO {

    public static enum Direction {

        ASC, DESC;

        @JsonValue
        public String value() {
            return name();
        }

        @JsonCreator
        public static Direction forValue(String value) {
            if (value == null || value.trim().isEmpty()) {
                throw new IllegalArgumentException("Sort Direction must not be null or empty: " + value);
            }

            return Direction.valueOf(value.trim().toUpperCase());
        }
    }
    private String property;
    private Direction direction;

    public SortVO() {
    }

    public String getProperty() {
        return property;
    }

    public void setProperty(String property) {
        this.property = property;
    }

    public Direction getDirection() {
        return direction;
    }

    public void setDirection(Direction direction) {
        this.direction = direction;
    }

    @Override
    public String toString() {
        return "SortUI{" + "property=" + property + ", direction=" + direction + '}';
    }
}
