package com.dataart.viewer.product.repository;

import com.dataart.viewer.product.model.impl.Product;
import java.util.List;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.querydsl.QueryDslPredicateExecutor;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author volkodavav
 */
@Transactional
public interface ProductRepository extends JpaRepository<Product, Long>, QueryDslPredicateExecutor<Product> {

    @Query("select count(p), pg.name from Product p RIGHT JOIN p.group pg GROUP BY pg.name ORDER BY pg.name")
    List<Object[]> countProductsGroupedByGroupName();

    List<Product> findByGroup_Name(String groupName);
}