package com.dataart.viewer.product.sample;

import com.dataart.viewer.product.util.SampleUtil;
import org.apache.commons.lang.Validate;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Class to create sample products
 *
 * @author volkodavav
 */
@Service
public class CreateProductDataListener implements InitializingBean {

    private Logger logger = LoggerFactory.getLogger(getClass());
    @Autowired
    private SampleUtil sampleUtil;

    @Override
    public void afterPropertiesSet() throws Exception {
        Validate.notNull(sampleUtil, "sampleUtil required");

        sampleUtil.createProductsWithGroups();
    }

    public void setSampleUtil(SampleUtil sampleUtil) {
        this.sampleUtil = sampleUtil;
    }
}
