package com.dataart.viewer.product.util;

import com.dataart.viewer.product.model.vo.ProductGroupVO;
import com.dataart.viewer.product.model.vo.ProductVO;
import com.dataart.viewer.product.service.ProductGroupService;
import com.dataart.viewer.product.service.ProductService;
import java.math.BigDecimal;
import org.apache.commons.lang.Validate;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 *
 * @author volkodavav
 */
@Component
public class SampleUtil implements InitializingBean {

    private Logger logger = LoggerFactory.getLogger(getClass());
    @Autowired
    private ProductService productService;
    @Autowired
    private ProductGroupService productGroupService;

    public void dropCreateProductsAndGroups() {
        logger.info("Dropping and creation of products and groups");
        productGroupService.deleteAllGroups();
        createProductsWithGroups();
    }

    public void createProductsWithGroups() {
        if (productService.count() > 0) {
            logger.info("Products exists");
            return;
        }

        logger.info("Creating new products");

        ProductVO product;
        String productGroup;

        productGroup = "Laptops & Netbooks";
        product = createProduct("Asus N56V", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Apple The new MacBook Air 13\" (MD760)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Lenovo IdeaPad V580A (59-370220)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Acer Aspire S3-391-53314G52add (NX.M1FEU.003)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Acer Aspire One D270-26Ckk (NU.SGAEU.006)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Lenovo IdeaPad Y500 (59-359659)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Apple The new MacBook Air 13\" (MD761)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS K56CB (K56CB-XX036)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("HP ENVY dv7-7388sr (E0R49EA)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Apple MacBook Pro 13\" with Retina display (MD212)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Acer Aspire One 756-1007CSS (NU.SGTEU.011)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Acer Aspire V5-531-987B4G50MASS (NX.M1HEU.002)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS U500VZ (U500VZ-CN097H)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Lenovo IdeaPad Z500A (59-369991)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Apple MacBook Pro (MD101)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS UX32VD (UX32VD-R4002H)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS K56CB (K56CB-XX037)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("HP Mini 200-4253sr (B3R59EA)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS S56CB (S56CB-XX280H)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Acer Aspire R7-571G (NX.MA5EU.002)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS UX31A (UX31A-R5006H)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Acer Aspire E1-531-10002G50Mnks (NX.M12EU.033)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Lenovo S206 (59-340472)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Fujitsu Lifebook NH532 (NH532MPZI5RU)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS X201E (X201E-KX023D)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("HP ENVY m6-1102sr (C5S15EA)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Fujitsu Lifebook NH532 (NH532M47A5RU)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS X75VC (X75VC-TY021D)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS VivoBook S300CA (S300CA-C1012H)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Apple MacBook Pro (MD102)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Apple MacBook Pro 13\" with Retina display (MD213)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Lenovo IdeaPad Z500A (59-359023)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS K55VD (K55VD-SX651D)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Dell Inspiron N5720 (210-38496pink)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Acer Aspire V3-571G-33124G75Makk (NX.M67EU.001)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS G75VX (G75VX-T4026H)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS X201E (X201E-KX002D)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS X55A (X55A-SX195D)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Lenovo G580G (59-362132)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Dell Inspiron 7720 (210-38392alu)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Sony VAIO SVD1321Z9R/B", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS G750JX (G750JX-T4084H)", randomBigDecimal(), productGroup);
        productService.save(product);


        productGroup = "Desktops";
        product = createProduct("Apple Mac mini new (MD387)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Apple iMac 21.5\" new MD093", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Apple iMac 27\" new MD096", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Apple iMac 27\" new MD095", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Apple Mac mini new (MD388)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Acer Aspire XC600 (DT.SLJME.018)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Lenovo ThinkCentre Edge 62z (RF5BCRU)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Dell Inspiron One 2330 (210-390897)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Lenovo IdeaCentre B540p (57-310399)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS All-in-One PC ET2300INTI-B088K (90PT00H1001400Q)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Dell XPS One 27 (210-400100)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Apple Mac mini (MC815)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Lenovo IdeaCentre C540 (57-313078)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Intel NUC (BOXDCCP847DYE)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("ASUS All-in-One PC ET2220INKI-B022K (90PT00G1001890Q)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Lenovo ThinkCentre Edge 92z (RBAGARU)", randomBigDecimal(), productGroup);
        productService.save(product);


        productGroup = "Printers";
        product = createProduct("Samsung ML-2165", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Canon PIXMA MP230 (6220B009)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Epson L800 (C11CB57301)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Canon Pixma iP2700", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("HP LaserJet Pro M1132 (CE847A)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Epson Stylus Photo PX660 (C11CA75312)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Epson Stylus SX130", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Canon MF4410", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Canon PIXMA MP280", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("HP Officejet Pro 8600 Plus (CM750A) (N911g)", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Samsung SCX-3405W", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Canon MF3010", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("Epson Expression Home XP-207", randomBigDecimal(), productGroup);
        productService.save(product);


        productGroup = "Scanners";
        ProductGroupVO productGroupVO = createProductGroup(productGroup);
        productGroupService.save(productGroupVO);


        productGroup = "Drives";
        product = createProduct("SKC300S3B7A/240G", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("SKC300S37A/180G", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("SKC300S37A/240G", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("SKC300S37A/180G", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("SKC300S3B7A/120G", randomBigDecimal(), productGroup);
        productService.save(product);

        product = createProduct("SKC300S37A/60G", randomBigDecimal(), productGroup);
        productService.save(product);

        logger.info("Products have been created successfully");
    }

    private ProductVO createProduct(String name, BigDecimal price, String productGroup) {
        ProductVO product = new ProductVO();
        product.setName(name);
        product.setPrice(price);
        product.setGroup(productGroup);

        return product;
    }

    private ProductGroupVO createProductGroup(String name) {
        ProductGroupVO productGroupVO = new ProductGroupVO();
        productGroupVO.setName(name);

        return productGroupVO;
    }

    public BigDecimal randomBigDecimal() {
        return new BigDecimal(Math.random() * 2000);
    }

    public void setProductService(ProductService productService) {
        this.productService = productService;
    }

    public void setProductGroupService(ProductGroupService productGroupService) {
        this.productGroupService = productGroupService;
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        Validate.notNull(productService, "productService expected");
        Validate.notNull(productGroupService, "productGroupService expected");
    }
}
