package com.dataart.viewer.product.web.controller;

import com.dataart.viewer.product.converter.ExtJsConverter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.apache.commons.lang.Validate;
import org.springframework.beans.factory.InitializingBean;

/**
 *
 * @author volkodavav
 */
public abstract class BaseController implements InitializingBean {

    protected Logger logger = LoggerFactory.getLogger(getClass());
    @Autowired
    protected ExtJsConverter extJsConverter;

    // logs exception and returns it's message
    protected String simpleExceptionHandler(Throwable th) {
        logger.error(th.getMessage(), th);
        return th.getMessage();
    }

    public void setExtJsConverter(ExtJsConverter extJsConverter) {
        this.extJsConverter = extJsConverter;
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        Validate.notNull(extJsConverter, "extJsConverter expected");
    }
}
