package com.dataart.viewer.product.web.controller;

import com.dataart.viewer.product.util.SampleUtil;
import org.apache.commons.lang.Validate;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

/**
 * Controller which handles *.html/*.jsp requests
 *
 * @author volkodavav
 */
@Controller
public class HtmlController extends BaseController {

    protected Logger logger = LoggerFactory.getLogger(getClass());
    @Autowired
    protected SampleUtil sampleUtil;

    @RequestMapping("recreateAllProducts")
    public String recreateAllData() {
        logger.info("Starting recreation of all data");
        sampleUtil.dropCreateProductsAndGroups();
        return "redirect:/logout";
    }

    @RequestMapping("/")
    public String welcome() {
        return "redirect:/index.jsp";
    }

    @RequestMapping("index.jsp")
    public String index() {
        return "/index";
    }

    public void setSampleUtil(SampleUtil sampleUtil) {
        this.sampleUtil = sampleUtil;
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        Validate.notNull(sampleUtil, "sampleUtil expected");
    }
}
