Ext.define('Shared.lib.DialogUtil', {
  showConfirmationDialog: function(dialogTitle, dialogMessage, dialogCallback) {
    Ext.MessageBox.confirm({
      title: dialogTitle,
      msg: dialogMessage,
      buttons: Ext.MessageBox.YESNO,
      icon: Ext.MessageBox.QUESTION,
      fn: dialogCallback,
      overflowY: 'auto'
    });
  },
  showSuccessDialog: function(dialogTitle, dialogMessage) {
    Ext.MessageBox.show({
      title: dialogTitle,
      msg: dialogMessage,
      buttons: Ext.MessageBox.OK,
      icon: Ext.MessageBox.INFO,
      overflowY: 'auto'
    });
  },
  showWarningDialog: function(dialogTitle, dialogMessage) {
    Ext.MessageBox.show({
      title: dialogTitle,
      msg: dialogMessage,
      buttons: Ext.MessageBox.OK,
      icon: Ext.MessageBox.WARNING,
      overflowY: 'auto'
    });
  },
  showErrorDialog: function(dialogTitle, dialogMessage) {
    Ext.MessageBox.show({
      title: dialogTitle,
      msg: dialogMessage,
      buttons: Ext.MessageBox.OK,
      icon: Ext.MessageBox.ERROR,
      overflowY: 'auto'
    });
  },
  showConfirmationDialogDefault: function(dialogMessage, dialogCallback) {
    Ext.MessageBox.confirm({
      title: APP_ENV['window.MessageBox.titleText.confirm'],
      msg: dialogMessage,
      buttons: Ext.MessageBox.YESNO,
      icon: Ext.MessageBox.QUESTION,
      fn: dialogCallback,
      overflowY: 'auto'
    });
  },
  showSuccessDialogDefault: function(dialogMessage) {
    Ext.MessageBox.show({
      title: APP_ENV['window.MessageBox.titleText.alert'],
      msg: dialogMessage,
      buttons: Ext.MessageBox.OK,
      icon: Ext.MessageBox.INFO,
      overflowY: 'auto'
    });
  },
  showWarningDialogDefault: function(dialogMessage) {
    Ext.MessageBox.show({
      title: APP_ENV['window.MessageBox.titleText.alert'],
      msg: dialogMessage,
      buttons: Ext.MessageBox.OK, icon: Ext.MessageBox.WARNING,
      overflowY: 'auto'
    });
  },
  showErrorDialogDefault: function(dialogMessage) {
    Ext.MessageBox.show({
      title: APP_ENV['window.MessageBox.titleText.alert'],
      msg: dialogMessage,
      buttons: Ext.MessageBox.OK,
      icon: Ext.MessageBox.ERROR,
      overflowY: 'auto'
    });
  }
});