Ext.define('Shared.lib.RequestUtil', {
  dialogUtil: Ext.create("Shared.lib.DialogUtil"),
  wrapDataWithRoot: function(data) {
    var wrappedData = {};
    wrappedData[APP_ENV['rootRestProperty']] = data;

    return wrappedData;
  },
  sendAjax: function(waitMessage, urlToPost, data, onSuccess, onFailure, ajaxMethod) {
    ajaxMethod = ajaxMethod || "POST";
    var me = this;
    var box = Ext.MessageBox.wait(waitMessage);

    try {
      Ext.Ajax.request({
        url: urlToPost,
        method: ajaxMethod,
        jsonData: data,
        success: function(response, opts) {
          box.hide();
          var objResponse = Ext.decode(response.responseText);
          if (objResponse.success) {
            onSuccess(objResponse);
          } else {
            onFailure(objResponse.message);
          }
        },
        failure: function(response, opts) {
          box.hide();
          var errorMessage = APP_ENV['app.js.ajax.response.statusText'] + ' ' + response.statusText + '; ' + APP_ENV['app.js.ajax.response.status'] + ' ' + response.status;
          onFailure(errorMessage);
        }
      });
    } catch (e) {
      box.hide();
      me.dialogUtil.showErrorDialogDefault(e);
      return false;
    }
  }
});