Ext.define('DataArt.store.Products', {
  extend: 'Ext.data.Store',
  model: 'DataArt.model.Product',
  remoteSort: true,
  remoteGroup: true,
  remoteFilter: true,
  autoLoad: false,
  pageSize: APP_ENV['defaulPaginatorPageSize'],
  proxy: {
    type: 'ajax',
    model: 'DataArt.model.Product',
    dialogUtil: Ext.create("Shared.lib.DialogUtil"),
    actionMethods: {
      read: 'GET'
    },
    api: {
      read: APP_ENV['getAllProductsRestUrl']
    },
    reader: {
      type: 'json',
      root: APP_ENV['rootRestProperty'],
      successProperty: APP_ENV['successRestProperty'],
      totalProperty: APP_ENV['totalRestProperty'],
      messageProperty: APP_ENV['messageRestProperty']
    },
    listeners: {
      exception: function(proxy, response, operation) {
        var me = this,
          message = APP_ENV['app.error.errorNotIdentified'];

        if (operation && operation.getError()) {
          var error = operation.getError();
          message = APP_ENV['app.js.ajax.response.statusText'] + ' ' + error.statusText + '; ' + APP_ENV['app.js.ajax.response.status'] + ' ' + error.status;
        }

        me.dialogUtil.showErrorDialog(APP_ENV['app.error.remote.exception.message'], message);
      }
    }
  }
});