<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags" %>

<c:set var="applicationName" scope="application" value="Product Viewer"/>
<html>
    <head>
        <title>${applicationName}</title>
        <meta http-equiv="refresh" content="${pageContext.session.maxInactiveInterval};URL='<c:url value="/"/>'" />
        <meta name="author" content="Anatolii Volkodav" />
        <meta name="description" content="With pleasure for DataArt! ;-)" />
        <link rel="icon" type="image/png" href='<c:url value="/resources/images/dataart-logo-icon.png"/>' />

        <!-- including common code -->
        <jsp:include page="/WEB-INF/jsp/templates/includes/extjs_head.jsp" />
        <script>
            var APP_ENV = (function() {
                return {
                    applicationCopyright: '&copy; Copyright 2013. Anatolii Volkodav with pleasure for DataArt! ;-)',
                    'app.message.title': '${applicationName}',
                    applicationRoot: '<c:url value="/"/>',
                    // REST Store properties
                    rootRestProperty: 'data',
                    successRestProperty: 'success',
                    totalRestProperty: 'total',
                    messageRestProperty: 'message',
                    // Page size
                    defaulPaginatorPageSize: 10,
                    // To mark text
                    attentionText: '<span style="color:red;font-weight:bold">{0}</span>',
                    // To mark required field
                    defaultRequiredField: '<span style="color:red;font-weight:bold" data-qtip="Required">*</span>',
                    // REST services
                    // Product services
                    getAllProductsRestUrl: '<c:url value="/product/getAllProducts.action"/>',
                    countProductsGroupedByGroupNameRestUrl: '<c:url value="/product/countProductsGroupedByGroupName.action"/>',
                    // Error messages
                    'app.error.errorNotIdentified': 'Error NOT Identified!',
                    'app.error.remote.exception.message': 'Remote Exception',
                    'app.js.ajax.response.statusText': 'response status text',
                    'app.js.ajax.response.status': 'response status',
                    'window.MessageBox.titleText.confirm': 'Confirm',
                    'window.MessageBox.titleText.prompt': 'Prompt',
                    'window.MessageBox.titleText.wait': 'Loading ...',
                    'window.MessageBox.titleText.alert': 'Attention',
                    // Entities fields
                    // Product entity
                    'product.id': 'ID #',
                    'product.name': 'Name',
                    'product.price': 'Price',
                    'product.group': 'Group',
                    // Product group entity
                    'productGroup.id': 'ID #',
                    'productGroup.name': 'Name'
                };
            })();
        </script>

        <script type="text/javascript" src="app/app.js"></script>
    </head>
    <body>
    </body>
</html>